#include <exec/types.h>
#include <exec/semaphores.h>
#include <exec/exec_protos.h>
#include <dos/dos.h>
#include <dos/dostags.h>
#include <dos/dos_protos.h>
#include <stdio.h>

struct pooh
{
    struct SignalSemaphore sem;
    ULONG counter;
};

int main(int argc, char *argv[])
{
    struct pooh *ss = NULL;

    Forbid();
    if((ss = (struct pooh *)FindSemaphore("pooh")))
    {
	int i;
	char *name = FindTask(NULL)->tc_Node.ln_Name;

	/* the semaphore exists */
	Permit();
	printf("%s: semaphore \"pooh\" existed\n", name);

	ObtainSemaphore((struct SignalSemaphore *)ss);
	ss->counter++;
	ReleaseSemaphore((struct SignalSemaphore *)ss);

	for(i=0;i<3;i++)
	{
	    ObtainSemaphoreShared((struct SignalSemaphore *)ss);
	    printf("%s: Counter: %d\n", name, ss->counter);
	    ReleaseSemaphore((struct SignalSemaphore *)ss);

	    Delay(5);
	}
	ObtainSemaphore((struct SignalSemaphore *)ss);
	ss->counter--;
	ReleaseSemaphore((struct SignalSemaphore *)ss);
	FreeSemaphore((struct SignalSemaphore *)ss);
    }
    else
    {
	int i;

	ss = (struct pooh *)AllocMem(sizeof(struct pooh), MEMF_CLEAR);
	AddSemaphore((struct SignalSemaphore *)ss, "pooh", 0);
	Permit();

	for(i=0;i<10;i++)
	{
	    struct SegList *segl = LoadSeg("semtest.b68k");
	    char name[40];

	    if(segl)
	    {
		sprintf(name, "SemTest%d", i);
		CreateNewProcTags(NP_Seglist, segl,
				  NP_FreeSeglist, TRUE,
				  NP_Output, Output(),
				  NP_CloseOutput, FALSE,
				  NP_Name, name);
	    }
	}
	Delay(100);
	while(1)
        {
	    ObtainSemaphore((struct SignalSemaphore *)ss);
	    if(ss->sem.ss_Public == 0)
	    {
		RemSemaphore((struct SignalSemaphore *)ss);
		break;
	    }
	    printf("Counter: %d\n", ss->counter);
	    ReleaseSemaphore((struct SignalSemaphore *)ss);
	    Delay(20);
        }
    }
    return 0;
}


