#ifndef EXEC_LIB_I
#define EXEC_LIB_I

#ifndef VECTSIZE
#define VECTSIZE	6
#endif

/* Interrupts */
LIB_Disable	= -3*VECTSIZE
LIB_Enable	= -4*VECTSIZE
LIB_Forbid	= -5*VECTSIZE
LIB_Permit	= -6*VECTSIZE
LIB_AddIntServer= -7*VECTSIZE
LIB_RemIntServer= -8*VECTSIZE
LIB_Cause       = -9*VECTSIZE

/* List Routines */
LIB_Insert      = -10*VECTSIZE
LIB_AddHead     = -11*VECTSIZE
LIB_AddTail     = -12*VECTSIZE
LIB_Remove      = -13*VECTSIZE
LIB_RemHead     = -14*VECTSIZE
LIB_RemTail     = -15*VECTSIZE
LIB_Enqueue     = -16*VECTSIZE
LIB_NewList     = -17*VECTSIZE
LIB_FindName	= -18*VECTSIZE

/* Memory Routines */
LIB_AllocMem    = -19*VECTSIZE
LIB_FreeMem     = -20*VECTSIZE
LIB_AvailMem    = -21*VECTSIZE
LIB_AllocRemember= -22*VECTSIZE
LIB_FreeRemember = -23*VECTSIZE
LIB_FreeRememberAll = -24*VECTSIZE

/* Task-related */
LIB_AddTask     = -25*VECTSIZE
LIB_RemTask	= -26*VECTSIZE
LIB_FindTask	= -27*VECTSIZE
LIB_SetTaskPri  = -28*VECTSIZE
LIB_SetSignal   = -29*VECTSIZE
/* Signals */
LIB_Wait	= -30*VECTSIZE
LIB_Signal	= -31*VECTSIZE
LIB_AllocSignal	= -32*VECTSIZE
LIB_FreeSignal	= -33*VECTSIZE
/* Resident programs */
LIB_AddProgram  = -34*VECTSIZE
LIB_RemProgram  = -35*VECTSIZE
LIB_FindProgram = -36*VECTSIZE

/* Ports/Messages */
LIB_AddPort	= -37*VECTSIZE
LIB_RemPort	= -38*VECTSIZE
LIB_CreatePort	= -39*VECTSIZE
LIB_DeletePort	= -40*VECTSIZE
LIB_FindPort	= -41*VECTSIZE
LIB_WaitPort	= -42*VECTSIZE
LIB_PutMsg	= -43*VECTSIZE
LIB_GetMsg	= -44*VECTSIZE
LIB_ReplyMsg	= -45*VECTSIZE

/* Devices */
LIB_AddDevice	= -46*VECTSIZE
LIB_RemDevice	= -47*VECTSIZE
LIB_OpenDevice	= -48*VECTSIZE
LIB_CloseDevice	= -49*VECTSIZE
LIB_DoIO	= -50*VECTSIZE
LIB_SendIO	= -51*VECTSIZE
LIB_CheckIO	= -52*VECTSIZE
LIB_WaitIO	= -53*VECTSIZE
LIB_AbortIO	= -54*VECTSIZE

/* Libraries */
LIB_AddLibrary	= -55*VECTSIZE
LIB_RemLibrary	= -56*VECTSIZE
LIB_InitLibFuncs= -57*VECTSIZE
LIB_OpenLibrary	= -58*VECTSIZE
LIB_CloseLibrary= -59*VECTSIZE
LIB_SetFunction	= -60*VECTSIZE

/* Resources */
LIB_AddResource = -61*VECTSIZE
LIB_RemResource = -62*VECTSIZE
LIB_AllocResource = -63*VECTSIZE
LIB_FreeResource =  -64*VECTSIZE

/* Misc */
LIB_DateStamp   = -65*VECTSIZE
LIB_SetDate     = -66*VECTSIZE
LIB_SendTimerReq= -67*VECTSIZE

/* More List Routines */
LIB_HeadNode = -68*VECTSIZE
LIB_TailNode = -69*VECTSIZE
LIB_NextNode = -70*VECTSIZE
LIB_PrevNode = -71*VECTSIZE

/* C call conventions (stack parameters) */
LIB_FlashInfo  = -72*VECTSIZE
LIB_FlashRes0  = -73*VECTSIZE
LIB_FlashRes1  = -74*VECTSIZE

LIB_FreeSemaphore = -75*VECTSIZE
LIB_InitSemaphore = -76*VECTSIZE
LIB_AddSemaphore  = -77*VECTSIZE
LIB_RemSemaphore  = -78*VECTSIZE
LIB_FindSemaphore = -79*VECTSIZE
LIB_AttemptSemaphore = -80*VECTSIZE
LIB_AttemptSemaphoreShared = -81*VECTSIZE
LIB_ObtainSemaphore = -82*VECTSIZE
LIB_ObtainSemaphoreShared = -83*VECTSIZE
LIB_ReleaseSemaphore = -84*VECTSIZE

LIB_NUMVEC = 84
LIB_NEGSIZE = LIB_NUMVEC*VECTSIZE


AbsExecBase = 4

#endif
