#ifndef EXEC_SYSTEM_I
#define EXEC_SYSTEM_I

BAR = 0xf2
SCR = 0xf4
BASE = 0x650000

CMR = BASE+0x802
SAPR = BASE+0x804
DAPR = BASE+0x808
BCR = BASE+0x80c
CSR = BASE+0x80e
FCR = BASE+0x810

GIMR = BASE+0x812
IPR = BASE+0x814
IMR = BASE+0x816
ISR = BASE+0x818

PACNT = BASE+0x81e
PADDR = BASE+0x820
PADAT = BASE+0x822
PBCNT = BASE+0x824
PBDDR = BASE+0x826
PBDAT = BASE+0x828

xilc_TCK = 0x0004
xilc_TMS = 0x0008
xilc_TDI = 0x0040
xilc_TDO = 0x0080
xilc_PROGRAM = 0x0100
xilc_CCLK    = 0x0200
xilc_DIN     = 0x0400
xilc_DONE    = 0x0800
xilc_INIT    = 0x1000
master_WDOG  = 0x8000

BR0 = BASE+0x830
OR0 = BASE+0x832
BR1 = BASE+0x834
OR1 = BASE+0x836
BR2 = BASE+0x838
OR2 = BASE+0x83a
BR3 = BASE+0x83c
OR3 = BASE+0x83e

TMR1 = BASE+0x840
TRR1 = BASE+0x842
TCR1 = BASE+0x844
TCN1 = BASE+0x846
TER1 = BASE+0x849
WRR = BASE+0x84a
WCN = BASE+0x84c
TMR2 = BASE+0x850
TRR2 = BASE+0x852
TCR2 = BASE+0x854
TCN2 = BASE+0x856
TER2 = BASE+0x859

CR = BASE+0x860

| UART definitions
SCCConf0 = BASE+0x880
SCCConf1 = BASE+0x890
SCCConf2 = BASE+0x8a0
SCON = 2
SCM  = 4
DSR  = 6
SCCE = 8
SCCM = 10
SCCS = 12

SCC0 = BASE+0x400
SCC1 = BASE+0x500
SCC2 = BASE+0x600
RFCR = 0x80
TFCR = 0x81
MRBLR = 0x82
RBDN = 0x87
TBDN = 0x93
MAX_IDL = 0x9c
IDLC = 0x9e
BRKCR = 0xa0
PAREC = 0xa2
FRMEC = 0xa4
NOSEC = 0xa6
BRKEC = 0xa8
UADDR1 = 0xaa
UADDR2 = 0xac
RCCR = 0xae
CHARACTER1 = 0xb0
CHARACTER2 = 0xb2
CHARACTER3 = 0xb4
CHARACTER4 = 0xb6
CHARACTER5 = 0xb8
CHARACTER6 = 0xba
CHARACTER7 = 0xbc
CHARACTER8 = 0xbe

BD_Status = 0
BD_Length = 2
BD_Address = 4
BD_SIZE = 8

SPMODE = BASE+0x8b0
SIMASK = BASE+0x8b2
SIMODE = BASE+0x8b4

I8255 = 0x620000
LCD   = 0x640000
DPRAM = 0x660000

FLASHBASE = 0x840000

/* Ethernet registers */
ETHER = 0x600000
E_CR = ETHER+0
E_DCR = ETHER+2
E_RCR = ETHER+4
E_TCR = ETHER+6
E_IMR = ETHER+8
E_ISR = ETHER+10
E_DCR2 = ETHER+126
E_UTDA = ETHER+12
E_CTDA = ETHER+14
E_URDA = ETHER+26
E_CRDA = ETHER+28
E_EOBC = ETHER+38
E_URRA = ETHER+40
E_RSA = ETHER+42
E_REA = ETHER+44
E_RRP = ETHER+46
E_RWP = ETHER+48
E_RSC = ETHER+86
E_CEP = ETHER+66
E_CAP2 = ETHER+68
E_CAP1 = ETHER+70
E_CAP0 = ETHER+72
E_CE = ETHER+74
E_CDP = ETHER+76
E_CDC = ETHER+78
E_CRCT = ETHER+88
E_FAET = ETHER+90
E_MPT = ETHER+92
E_WT0 = ETHER+82
E_WT1 = ETHER+84
E_SR = ETHER+80

#endif
