#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include <dos/dos_protos.h>
#include <exec/exec_protos.h>

static int rand()
{
    return *(UWORD *)0x650846;
}

static char screen[16][26];
static const char * const pieces[7]=
{
    "     ##  ##                                                     ",
    "    ####         #   #   #   #                                  ",
    "     ## ##       #   ##   #                                     ",
    "    ##   ##       #  ##  #                                      ",
    "      #  ###      #  ##   #         ###  #           #   ##  #  ",
    "    ###   #          ##  #   #       #   ###      #   #  ##     ",
    "      # ###          ##   #   #      ### #       #   #   ##     "
};
static const char colors[8]="#O08@&X";
static const char palamax[7]={1,2,2,2,4,4,4};


static int fits(int pala,int x,int y,int s)
{
    int i;

    for(i=0;i<16;i++)
    {
	if(pieces[pala][s*16+i] != ' ' &&
	   screen[x + (i%4)][y + (i/4)] != ' ')
	    return 0;
    }
    return -1;
}

static int full()
{
    int f,g,rivi;

    for(f=1;f<21;f++)
    {
	rivi = 0;
	for(g=1;g<11;g++)
	{
	    if(screen[g][f]!=' ')
		rivi++;
	}
	if(rivi==10)
	    return f;
    }
    return -1;
}

static void initscreen(APTR io)
{
    int f,g,h;
    char temp[100];

    sprintf(temp, "\033[0;0H\033[2J\033[%d;%dHscore:\033[%d;%dHlines:\033[%d;%dHlevel:",
	    10, 53,
	    11, 53,
	    12, 53);
    Write(io, temp, strlen(temp));

    for(f=0;f<21;f++)
    {
	for(g=0;g<12;g++)
	{
	    screen[g][f]= ' ';
	    if(!g || g==11)
		screen[g][f]='|';
	    if(!f)
		screen[g][f]='^';
	}
    }
    for(f=0;f<21;f++)
    {
	sprintf(temp, "\033[%d;%dH", 22-f, 2);
	h = strlen(temp);
	for(g=0;g<12;g++)
	{
	    temp[h++] = screen[g][f];
	    temp[h++] = screen[g][f];
	}
	temp[h] = '\0';
	Write(io, temp, h);
    }
}

static void remove_piece(APTR io,int rivi)
{
    int f,g,h;
    char temp[100];

    for(f=rivi;f<19;f++)
    {
	sprintf(temp, "\033[%d;%dH", 22-f, 2);
	h = strlen(temp);
	for(g=0;g<12;g++)
	{
	    screen[g][f]=screen[g][f+1];
	    temp[h++] = screen[g][f];
	    temp[h++] = screen[g][f];
	}
	temp[h] = '\0';
	Write(io, temp, h);
    }
    for(g=1;g<11;g++)
	screen[g][19]=' ';
}

static void put(APTR io,int pala,int x,int y,int s,char vari)
{
    int f;
    char temp[80];

    for(f=0;f<16;f++)
    {
	if(pieces[pala][s*16+f] != ' ')
	{
	    screen[x+(f%4)][y+(f/4)] = vari;
	    sprintf(temp, "\033[%d;%dH%c%c", 22-(y+(f/4)), 2*(x+(f%4))+2, vari, vari);
	    Write(io, temp, strlen(temp));
	}
    }
}

static void disppiece(APTR io,int pala,int x,int y,int s,char vari)
{
    int f;
    char temp[80];

    for(f=0;f<16;f++)
    {
	if(pieces[pala][s*16+f] != ' ')
	{
	    sprintf(temp, "\033[%d;%dH%c%c", 22-(y+(f/4)), 2*(x+(f%4))+2, vari, vari);
	    Write(io, temp, strlen(temp));
	}
    }
}

static void dispscore(APTR io,int score, int lines, int level)
{
    char temp[80];

    sprintf(temp, "\033[%d;%dH%d\033[%d;%dH%d\033[%d;%dH%d",
	    10,60,score,
	    11,60,lines,
	    12,60,level);
    Write(io, temp, strlen(temp));
}


int main(struct Task *parent)
{
    short pala,x,y,s,level,laskuri,lines,score,xe,ye,se,len;
    char key[10],vari,loppu,alhaalla,drop,out[80];
    APTR io;/*= (APTR)FindTask(NULL)->tc_UserData;*/

    io = Output();
    SetMode(io, MODE_RAW);
    initscreen(io);
    lines = level = score = laskuri = loppu = 0;

    while(!loppu)
    {
	pala = (rand()/2)%7;
	s = 0;
	x = 5;
	y = 18;
	alhaalla = 0;
	drop = 0;
	vari = colors[(rand()/2)%7];
	disppiece(io,pala,x,y,s,vari);
	while(!alhaalla)
	{
	    xe=x;
	    ye=y;
	    se=s;
	    if(!fits(pala,x,y,s))
	    {
		loppu = 1;
		alhaalla = 1;
		break;
	    }
	    while(WaitForChar(io, 0) && (len=Read(io, key, 1)))
	    {
		if(len!=1)
		{
		    sprintf(out, "\033[24;0HRead() returned %d !", len);
		    Write(io, out, strlen(out));
		}
		if(key[0] == 0x03)
		{
		    loppu = 1;
		    alhaalla = 1;
		    break;
		}
		if(key[0] == '8')
		{
		    if(++s==palamax[pala])
			s = 0;
		    
		    if(!fits(pala,x,y,s))
		    {
			s = se;
		    }
		}
		if(key[0] == '5')
		{
		    if(--s<0)
			s = palamax[pala]-1;
		    
		    if(!fits(pala,x,y,s))
		    {
			s = se;
		    }
		}
		if(key[0] == '4')
		{
		    if(fits(pala,x-1,y,s))
		    {
			x--;
		    }
		}
		if(key[0] == '6')
		{
		    if(fits(pala,x+1,y,s))
		    {
			x++;
		    }
		}
		if(key[0] == ' ' || key[0] == '2')
		{
		    drop = 1;
		}
	    }
	    laskuri++;
	    if(drop)
		score += (16-y)/3 + ((level+1)*y)/5;

	    Delay(3);
	    while(laskuri>20-2*level || drop)
	    {
		laskuri = 0;
		y--;
		if(!fits(pala,x,y,s))
		{
		    alhaalla = 1;
		    y++;
		    if(!drop)
			score += (16-y)/3;
		    drop = 0;
		    put(io,pala,x,y,s,vari);
		}
	    }
	    if(x!=xe || y!=ye || s!=se)
	    {
		disppiece(io,pala,xe,ye,se,' ');
		disppiece(io,pala,x,y,s,vari);
	    }
	    level = lines/10;
	}
	dispscore(io, score, lines, level);
	while(full()>-1)
	{
	    remove_piece(io,full());
	    lines++;
	}
    }
    Write(io, "\033[25;1H", 7);
    SetMode(io, MODE_CONSOLE);
    return 0;
}
