#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos/dos.h>
#include <exec/exec_protos.h>

int main(void)
{
    APTR lock, file;
    struct FileInfoBlock *fib = calloc(sizeof(struct FileInfoBlock),1);
    struct FileLock lukko,*fl = &lukko;
    LONG error,i;
    struct Process *ram = (struct Process *)FindTask("ram-handler");

    if(ram)
    {
	printf("%s:\n", ram->pr_Task.tc_Node.ln_Name);
	printf("pr_StackTop:    0x%06x\n", ram->pr_StackTop);
	printf("tc_SPReg:       0x%06x\n", ram->pr_Task.tc_SPReg);
	printf("pr_StackBottom: 0x%06x\n", ram->pr_StackBottom);
	fflush(stdout);
    }

    ram = (struct Process *)FindTask(NULL);
    if(ram)
    {
	printf("%s:\n", ram->pr_Task.tc_Node.ln_Name);
	printf("pr_StackTop:    0x%06x\n", ram->pr_StackTop);
	printf("tc_SPReg:       0x%06x\n", ram->pr_Task.tc_SPReg);
	printf("pr_StackBottom: 0x%06x\n", ram->pr_StackBottom);
	fflush(stdout);
    }

    if(!fib)
    {
	printf("No memory!\n");
	return 20;
    }
    if(file = Open("RAM:test", MODE_OLDFILE))
    {
	printf("OldOpen succeeded\n");
	error = 0;
	while(i = Read(file, (char *)fib, sizeof(struct FileInfoBlock)))
	    error += i;
	printf("%d bytes read\n", error);
	Close(file);
    }

    if(file = Open("RAM:test", MODE_NEWFILE))
    {
	printf("NewOpen succeeded\n");
	printf("%d bytes written\n", Write(file, "huihai\n", 7));
	for(i=0;i<200;i++)
	{
	    if(Write(file, (char *)fib, sizeof(struct FileInfoBlock)) !=
	       sizeof(struct FileInfoBlock))
	    {
		printf("Write error in %d!\n", i);
		break;
	    }
	}
	Close(file);
    }
    else
	printf("NewOpen failed %d\n", IoErr());

    if(DeleteFile("RAM:testdir"))
	printf("RAM:testdir deleted\n");
    else
	printf("RAM:testdir not deleted\n");

    if(lock = CreateDir("RAM:testdir"))
    {
	printf("RAM:testdir created\n");
	error = UnLock(lock);
	printf("UnLock(): %d %d\n", error, IoErr());
	fflush(stdout);
    }
    else
    {
	printf("RAM:testdir not created!\n");
	fflush(stdout);
    }
    if(lock = CreateDir("RAM:testdir"))
    {
	printf("RAM:testdir created\n");
	error = UnLock(lock);
	printf("UnLock(): %d %d\n", error, IoErr());
	fflush(stdout);
    }
    else
    {
	printf("RAM:testdir not created!\n");
	fflush(stdout);
    }

    if(lock = Lock("RAM:testdir", ACCESS_READ))
    {
	printf("RAM:testdir locked\n");
	fl = (struct FileLock *)lock;
	printf("Lock: 0x%08x FileLock: 0x%08x fl_Key: 0x%08x fl_Task: 0x%08x\n",
	       lock,
	       fl,
	       fl->fl_Key,
	       fl->fl_Task);
	error = UnLock(lock);
	/*error = DoPkt4(fl->fl_Task, ACTION_UNLOCK, (ULONG)lock, 0, 0, 0);*/
	printf("UnLock(): %d 0x%08x\n", error, IoErr());
	fflush(stdout);
    }
    else
    {
	printf("RAM:testdir not locked!\n");
	fflush(stdout);
    }

    if((lock = Lock("RAM:", ACCESS_READ)))
    {
	if(Examine(lock, fib))
	{
	    printf("Name: %s %s\n", fib->fib_FileName,
		   fib->fib_DirEntryType<0?"[File]":"[Dir]");
	    fflush(stdout);
	    while(ExNext(lock, fib))
	    {
		printf("\tName: %s %s %d Bytes\n",
		       fib->fib_FileName,
		       fib->fib_DirEntryType<0?"[File]":"[Dir]",
		       fib->fib_Size);
		fflush(stdout);
	    }
	    ExamineEnd(lock, fib);
	}
	fl = (struct FileLock *)lock;
	printf("FileLock: fl_Key: 0x%08x\n", fl->fl_Key);
	error = UnLock(lock);
	printf("UnLock(): %d %d\n", error, IoErr());
    }
    else
    {
	printf("Lock not successful\n");
	fflush(stdout);
    }
    free(fib);
    return 0;
}
