#ifndef EXEC_EXEC_H
#define EXEC_EXEC_H

#include <exec/types.h>
#include <exec/libraries.h>
#include <exec/memory.h>

struct DateStamp
{
    LONG ds_Days;	/* Number of days since Jan. 1, 1978 */
    LONG ds_Minutes;	/* Number of minutes past midnight */
    LONG ds_Ticks;	/* Number of ticks past minute */
};


struct Interrupt
{
    struct MinNode is_Node;		/* For exec linking	*/
    ULONG    is_Data;			/* server data segment  */
    VOID    (*is_Code)(ULONG is_Data,UWORD *stackframe);
    /* server code entry    */
};


struct ExecBase
{
    struct Library LibNode;
    ULONG  SysStkUpper;
    ULONG  SysStkLower;

    struct List  IntVects[88]; /* 64-87 are EXRQ and INRQ sources*/

    struct  Task *ThisTask;
    UWORD   Quantum;
    UWORD   ExecPrivate;

    UWORD   AttnResched;
    UWORD   Version;
    ULONG   DispCount;

    UWORD   IDNestCnt;
    UWORD   TDNestCnt;

    struct List  TaskReady;
    struct List  TaskWait;

    struct List  ResourceList;
    struct List  DeviceList;
    struct List  LibList;
    struct List  PortList;
    struct List  TimerRequests;
    struct List  ProgramList;
    struct List  SemaphoreList;

    struct  DateStamp SystemTime;
    struct  Memory *MemoryList;
};

#endif	/* EXEC_EXECBASE_H */
