#ifndef	EXEC_SEMAPHORES_H
#define	EXEC_SEMAPHORES_H

#include <exec/lists.h>
#include <exec/io.h>

/****** SignalSemaphore *********************************************/

/* Signal Semaphore data structure */
struct SignalSemaphore
{
    struct Node	ss_Node;
    UWORD       ss_Public;
    WORD	ss_NestCount;
    WORD	ss_QueueCount;
    struct List ss_WaitQueue;
    struct Task *ss_Owner;
};

void InitSemaphore(struct SignalSemaphore *);
void AddSemaphore(struct SignalSemaphore *s,const char *name,BYTE pri);
void RemSemaphore(struct SignalSemaphore *);
struct SignalSemaphore *FindSemaphore(const char *name);
void FreeSemaphore(struct SignalSemaphore *);

LONG AttemptSemaphore(struct SignalSemaphore *);
LONG AttemptSemaphoreShared(struct SignalSemaphore *);

void ObtainSemaphore(struct SignalSemaphore *);
void ObtainSemaphoreShared(struct SignalSemaphore *);
void ReleaseSemaphore(struct SignalSemaphore *);

#endif
