#include "stdio.h"
#include "stdlib.h"
#include <dos/dosdefines.h>
#include <exec/lists.h>
#include <dos/dos_protos.h>

FILE *fopen(const char *name, const char *mode) {
    int rwmode;
    ULONG callmode = 0;
    BOOL seekend = FALSE;
    FILE *newf;

    __chkabort();

    if (!name || !mode) return NULL;

    switch (*mode++) {
    case 'r': rwmode = 0; break;
    case 'w': rwmode = 1; break;
    case 'a': rwmode = 2; break;
    default: return NULL;
    }

    newf = calloc(1, sizeof(FILE));
    if(!newf) return NULL;

    newf->flags = 0;

    switch (rwmode  + ((*mode == '+') ? 3 : 0)) {
    case 0:
	callmode = MODE_OLDFILE;
	break;
    case 1:
	callmode = MODE_NEWFILE;
	break;
    case 2:
	callmode = MODE_READWRITE;
	seekend = TRUE;
	break;
    case 3:
	callmode = MODE_READWRITE;
	break;
    case 4:
	callmode = MODE_NEWFILE;
	break;
    case 5:
	callmode = MODE_READWRITE;
	seekend = TRUE;
	break;
    }

    /* all values initially set to 0, only !0 values has to be set here */
    newf->buf = malloc(__DEFAULT_BUFSIZE);
    if(!newf->buf)
    {
	free(newf);
	return NULL;
    }
    newf->bufsize = __DEFAULT_BUFSIZE;
    newf->flags = __FF_SYSBUF;
    newf->bufmode = _IOFBF;
    newf->unc = -1;

    if (!(newf->filehandle = Open(name, callmode)))
    {
	free(newf->buf);
	free(newf);
	return NULL;
    }

    if (seekend) Seek(newf->filehandle, 0, OFFSET_END);

    AddHead(&__openfiles, (struct Node *) newf);

    return newf;
}
