#include "time.h"
#include <dos/dos.h>

struct tm *gmtime(const time_t *tp)
{
    long n, tmp;
    BOOL error = FALSE;

    if (*tp < 0)
	error = TRUE;

    if (!error)
    {
	tmp = n = *tp/(24*60*60)+306+365;

	__systm.tm_year = (4*n+3)/1461; /* Handle leap years */
	n -= 1461*(long)__systm.tm_year/4;
	__systm.tm_mon = (5*n+2)/153;   /* Get the # of months after Feb */
	__systm.tm_mday = n-(153*__systm.tm_mon+2)/5;
	__systm.tm_mon += 2;
	if(__systm.tm_mon > 11)
	{
	    __systm.tm_year++;
	    __systm.tm_mon -= 12;
	}
	__systm.tm_year += 76;

	if(__systm.tm_mday<0 || __systm.tm_mday>30 ||
	   __systm.tm_mon<0 || __systm.tm_mon>11 ||
	   __systm.tm_year<78)
	{
	    error = TRUE;
	} else {
	    __systm.tm_isdst = -1;
	    __systm.tm_yday = __ydays[(__systm.tm_year % 4) ? 0 : 1]
		                     [__systm.tm_mon] + __systm.tm_mday;
	    __systm.tm_wday = (tmp + 1) % 7;
	    tmp = *tp % (24*60*60);
	    __systm.tm_hour = tmp / (60*60);
	    tmp %= (60*60);
	    __systm.tm_min = tmp / 60;
	    __systm.tm_sec = tmp % 60;
	}
    }

    if (error)
	return NULL;
    else
	return &__systm;
}

