#include "string.h"

typedef unsigned long ULONG;

void *memcpy(void *D, const void *S, size_t n)
{
    char *r = D, *d = D;
    const char *s = S;

    if (((ULONG)d)&1 && (((ULONG)s)&1) && n)
    {
	*d++ = *s++;
	n--;
    }

    if ((!(((ULONG)d)&1)) && (!(((ULONG)s)&1)))
    {
	ULONG *dl = (ULONG *) d;
	const ULONG *sl = (ULONG *) s;
	ULONG i = n>>2;

	while (i--) *dl++ = *sl++;
	s = (const char *) sl;
	d = (char *) dl;

	n &= 3;
    }

    while (n--) *d++ = *s++;

    return r;
}

