#include <stdlib.h>
#include <ctype.h>

/*
   Unlike the specification says, this will ALSO work for unsigned
   longs; you'll just have to cast the result to (unsigned long)
   after you have received it
*/

long strtol(const char *s, char **endp, int base)
{
    unsigned long v = 0;
    short ishex = 0;
    short c;
    short neg = 0;

    while (isspace(*s))
	++s;

    if (*s == '-')
    {
	neg = 1;
	++s;
    }
    else
    {
	if (*s == '+') ++s;
    }

    if (s[0] == '0' && tolower(s[1]) == 'x')
	ishex = 1;

    if (base == 0)
    {
	base = 10;
	if (s[0] == '0')
	{
	    base = 8;
	    if (ishex)
		base = 16;
	}
    }
    if (base == 16 && ishex)
	s += 2;

    while(1)
    {
	c = tolower(*s);
	if (isdigit(c))
	    c -= '0';
	else if (isalpha(c))
	    c -= ('a' - 10);
	else
	    break;
	if (c >= base)
	    break;
	v = v * base + c;
	++s;
    }

    if (endp) *endp = (char *)s;
    if (neg && v != 0x80000000)
	return - (long) v;
    else
	return (long) v;
}
