/* ctype.h (C) 1994 Henrik Herranen			*/

/* This ctype can handle 8-bit ANSI characters and	*/
/* EOF (-1), as defined in the ANSI standard. Any 	*/
/* input outside range -1...255 is illegal.		*/

#ifndef CTYPE_H
#define CTYPE_H

extern const unsigned char __LeoCType[];

#define _U 1	/* upper case flag			*/
#define _L 2	/* lower case flag			*/
#define _N 4	/* number flag				*/
#define _S 8	/* space flag				*/
#define _P 16	/* punctuation flag			*/
#define _C 32	/* control character flag		*/
#define _B 64	/* blank flag				*/
#define _X 128	/* hexadecimal flag			*/

#define tolower(c)     (isupper(c) ? ((c)+('a'-'A')) : (c))
#define toupper(c)     (islower(c) ? ((c)-('a'-'A')) : (c))

#define isalnum(c)      (__LeoCType[(c)+1] & (_U|_L|_N))
#define isalpha(c)      (__LeoCType[(c)+1] & (_U|_L))
#define iscntrl(c)      (__LeoCType[(c)+1] & _C)
#define isdigit(c)      (__LeoCType[(c)+1] & _N)
#define isgraph(c)      (__LeoCType[(c)+1] & (_P|_U|_L|_N))
#define islower(c)      (__LeoCType[(c)+1] & _L)
#define isprint(c)      (__LeoCType[(c)+1] & (_P|_U|_L|_N|_B))
#define ispunct(c)      (__LeoCType[(c)+1] & _P)
#define isspace(c)      (__LeoCType[(c)+1] & _S)
#define isupper(c)      (__LeoCType[(c)+1] & _U)
#define isxdigit(c)     (__LeoCType[(c)+1] & _X)

#endif
