#include <stdio.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <exec/execbase.h>
#include <exec/exec_protos.h>

static struct DateStamp myds;

int main(int argc, char **argv) {
    struct tm *tm;
    struct tm mytm;
    struct DateStamp *ds;
    time_t tp;

    if (argc < 2)
    {
	printf("No command line arguments given\n");
	DateStamp(&myds);
	printf("Day: %02ld, Min:%02ld, Ticks:%02ld\n",
	       myds.ds_Days, myds.ds_Minutes, myds.ds_Ticks);
	printf("The time is %d seconds total\n\n", time(&tp));
	tm = gmtime(&tp);
	if (tm)
	{
	    char tmpstr[80];
	    printf("Universal time:\n%4d-%02d-%02d, time=%2d:%02d:%02d,"
		                                    "wday=%d, yday=%d\n",
		   tm->tm_year+1900, tm->tm_mon+1, tm->tm_mday+1,
		   tm->tm_hour, tm->tm_min, tm->tm_sec,
		   tm->tm_wday, tm->tm_yday);
	    strftime(tmpstr, 80, "It is %A, %d-%b-%y at %H:%M:%S", tm);
	    printf("%s\n", tmpstr);
	    strftime(tmpstr, 80, "The date is %x, time is %X", tm);
	    printf("%s\n\n", tmpstr);
	}
	else
	{
	    printf("Universal time is not available!\n");
	}
	tm = localtime(&tp);
	if (tm)
	{
	    char tmpstr[80];
	    printf("Local time:\n%4d-%02d-%02d, time=%2d:%02d:%02d,"
		                                    "wday=%d, yday=%d\n",
		   tm->tm_year+1900, tm->tm_mon+1, tm->tm_mday+1,
		   tm->tm_hour, tm->tm_min, tm->tm_sec,
		   tm->tm_wday, tm->tm_yday);
	    strftime(tmpstr, 80, "It is %A, %d-%b-%y at %H:%M:%S", tm);
	    printf("%s\n", tmpstr);
	    strftime(tmpstr, 80, "The date is %x, time is %X", tm);
	    printf("%s\n\n", tmpstr);
	}
	else
	{
	    printf("Local time is not available!\n");
	}
    }
    else if (!strcmp(argv[1], "set0"))
    {
	DateStamp(&myds);
	myds.ds_Days = 0;
	SetDate(&myds);
	printf("Day set to 0!\n");
    }
    else if (!strcmp(argv[1], "set"))
    {
	DateStamp(&myds);
	if (argc == 2)
	{
	    printf("Usage: set DAYS [MINUTES [TICKS]]\n");
	}
	else
	{
	    myds.ds_Days = atoi(argv[2]);
	    printf("Days set to %d\n", myds.ds_Days);
	    if (argc > 3)
	    {
		myds.ds_Minutes = atoi(argv[3]);
		printf("Minutes set to %d\n", myds.ds_Minutes);
		if (argc > 4)
		{
		    myds.ds_Ticks = atoi(argv[4]);
		    printf("Ticks set to %d\n", myds.ds_Ticks);
		}
	    }
	    SetDate(&myds);
	}
    }
    else if (!strcmp(argv[1], "setdate"))
    {
	DateStamp(&myds);
	if (argc < 7)
	{
	    printf("Usage: setdate YEAR MON DAY HOUR MIN [gmt]\n");
	}
	else
	{
	    mytm.tm_year = atoi(argv[2]);
	    if (mytm.tm_year > 1900) mytm.tm_year -= 1900;
	    mytm.tm_mon = atoi(argv[3]) - 1;
	    mytm.tm_mday = atoi(argv[4]) - 1;
	    mytm.tm_hour = atoi(argv[5]);
	    mytm.tm_min = atoi(argv[6]);
	    mytm.tm_sec = 0;
	    ds = tmtods(&mytm);

	    if (argc < 8 || strcmp(argv[7], "gmt"))
		ds->ds_Minutes -= tzminutes();

	    if (ds->ds_Minutes < 0)
	    {
		ds->ds_Minutes += 60*24;
		ds->ds_Days--;
	    }
	    else if (ds->ds_Minutes >= 60*24)
	    {
		ds->ds_Minutes -= 60*24;
		ds->ds_Days++;
	    }

	    SetDate(ds);
	}
    }
    else
    {
	printf("Valid commands are:\n"
	       "set0\n"
	       "set DAYS [MINUTES [TICKS]]\n"
	       "setdate YEAR MON DAY HOUR MIN [SEC]\n"
	       );
    }

    return 0;
}
