#include <exec/types.h>

struct sonicregs
{
    volatile UWORD Command; /* 0 */
    /*
       15 14 13 12 11 10   09   08   07  06  05  04   03   02   01  00
       0  0  0  0  0  0  LCAM RRRA  RST   0  ST STP RXEN RXDIS TXP HTX
       */
    volatile UWORD DataConfiguration; /* 1 */
    /*
       15   14  13  12  11   10   09   08  07  06 05  04   03   02   01   00
       EXBUS 0 LBR PO1 PO0 SBUS USR1 USR0 WC1 WC0 DW BMS RTF1 RTF0 TFT1 TFT0
       */
    volatile UWORD ReceiveControl; /* 2 */
    /*
       15   14  13  12  11  10  09 08 07   06  05  04   03   02  01  00
       ERR RNT BRD PRO AMC LB1 LB0 MC BC LPKT CRS COL CRCR FAER LBK PRX
       */
    volatile UWORD TransmitControl; /* 3 */
    volatile UWORD InterruptMask; /* 4 */
    volatile UWORD InterruptStatus; /* 5 */

    volatile UWORD UpperTransmitDescriptorAddress; /* 6 */
    volatile UWORD CurrentTransmitDescriptorAddress; /* 7 */

    volatile UWORD TransmitPacketSize; /* 8 */
    volatile UWORD TransmitFragmentCount; /* 9 */
    volatile UWORD TransmitStartAddress0; /* a */
    volatile UWORD TransmitStartAddress1; /* b */
    volatile UWORD TransmitFragmentSize; /* c */

    volatile UWORD UpperReceiveDescriptorAddress; /* d */
    volatile UWORD CurrentReceiveDescriptorAddress; /* e */

    volatile UWORD CurrentReceiveBufferAddress0; /* f */
    volatile UWORD CurrentReceiveBufferAddress1; /* 10 */
    volatile UWORD RemainingBufferWordCount0; /* 11 */
    volatile UWORD RemainingBufferWordCount1; /* 12 */

    volatile UWORD EndOfBufferWordCount; /* 13 */
    volatile UWORD UpperReceiveResourceAddress; /* 14 */
    volatile UWORD ResourceStartAddress; /* 15 */
    volatile UWORD ResourceEndAddress; /* 16 */
    volatile UWORD ResourceReadPointer; /* 17 */
    volatile UWORD ResourceWritePointer; /* 18 */

    volatile UWORD TemporaryReceiveBufferAddress0; /* 19 */
    volatile UWORD TemporaryReceiveBufferAddress1; /* 1a */

    volatile UWORD TemporaryBufferWordCount0; /* 1b */
    volatile UWORD TemporaryBufferWordCount1; /* 1c */

    volatile UWORD AddressGenerator0; /* 1d */
    volatile UWORD AddressGenerator1; /* 1e */

    volatile UWORD LastLinkFieldAddress; /* 1f */

    volatile UWORD TemporaryTransmitDescriptorAddress; /* 20 */

    volatile UWORD CAMEntryPointer; /* 21 */
    volatile UWORD CAMAddressPort2; /* 22 */
    volatile UWORD CAMAddressPort1; /* 23 */
    volatile UWORD CAMAddressPort0; /* 24 */
    volatile UWORD CAMEnable; /* 25 */
    volatile UWORD CAMDescriptorPointer; /* 26 */
    volatile UWORD CAMDescriptorCount; /* 27 */

    volatile UWORD SiliconRevision; /* 28 */

    volatile UWORD WatchdogTimer0; /* 29 */
    volatile UWORD WatchdogTimer1; /* 2a */

    volatile UWORD ReceiveSequenceCounter; /* 2b */

    volatile UWORD CRCErrorTally; /* 2c */
    volatile UWORD FAETally; /* 2d */
    volatile UWORD MissedPacketTally; /* 2e */

    volatile UWORD MaximumDeferralTime; /* 2f */

    volatile UWORD NationalFactoryTest[15]; /* 30 .. 3e */

    volatile UWORD DataConfiguration2; /* 3f */
};

/* Interrupt status register flags */
#define ISR_RFO   (1<<0)
#define ISR_MP    (1<<1)
#define ISR_FAE   (1<<2)
#define ISR_CRC   (1<<3)
#define ISR_RBAE  (1<<4)
#define ISR_RBE   (1<<5)
#define ISR_RDE   (1<<6)
#define ISR_TC    (1<<7)
#define ISR_TXER  (1<<8)
#define ISR_TXDN  (1<<9)
#define ISR_PKTRX (1<<10)
#define ISR_PINT  (1<<11)
#define ISR_LCD   (1<<12)
#define ISR_HBL   (1<<13)
#define ISR_BR    (1<<14)
#define ISR_RES   (1<<15)

